package RoguelikeTime;


import org.newdawn.slick.*;
import org.newdawn.slick.state.*;

public class Game extends BasicGame {

	public final static String gamename = "Sneak Peak - An F+J Adventure";
	public final int menu = 0;
	public final int play = 1;
	public final int win = 2;
	
	public int state = 0;
	
	public Menu menuState;
	public Play playState;
	public Win winState;
	
	public Game(String name) {
		super(name);
		menuState = new Menu(menu);
		playState = new Play(play);
		winState = new Win(win);
	}
	
	public void initStatesList(GameContainer gc) throws SlickException {
		menuState.init(gc, this);
		playState.init(gc, this);
	}

	private State getState() {
		if(state == play){
			return playState;
		}else if(state == win){
			return winState;
		}else{
			return menuState;
		}
	}

	public void enterState(int entering) {
		state = entering;
	}

	public static void main(String[] args) {
		
		AppGameContainer appgc;
		try{
			appgc = new AppGameContainer(new Game(gamename));
			appgc.setDisplayMode(800, 600, false);
			//appgc.setVSync(true);
			appgc.setShowFPS(false);
			appgc.start();
		}catch(Exception e){
			System.out.println("Whoops, something fucked up!");
			e.printStackTrace();
		}
	}
	
	public void init(GameContainer gc)
			throws SlickException {
		menuState.init(gc, this);
		playState.init(gc, this);
		enterState(menu);
		
	}

	public void render(GameContainer gc, Graphics g)
			throws SlickException {
		getState().render(gc, this, g);
		
	}

	public void update(GameContainer gc, int delta)
			throws SlickException {
		getState().update(gc, this, delta);
		
	}
}
