package RoguelikeTime;


import org.newdawn.slick.*;

public class Play extends State{

	private Image testmap;
	private SpriteSheet bricks;
	private Image Blue;
	private Image shadow;
	
	private int mapW = 0;
	private int mapH = 0;
	
	private float camX = 0;
	private float camY = 0;
	private int desX = 0;
	private int desY = 0;
	
	
	private byte[][] level;
	private byte[][] ninjalevel;
	private Image[][] tiles;
	private Image bg;
	private boolean moving = false;
	private int movedown;
	private int attackdown;

	private SpriteSheet Finn;
	private Image Jake;
	private Image Snail;
	private SpriteSheet attack;
	private SpriteSheet Ninja;
	private byte dir;
	private int anim;
	
	private int zoom = 4;
	
	
	public Play(int state){
		super(state);
	}
	
	public float getHex(Color color){
		return (color.getRedByte()*65536) + (color.getGreenByte()*256) + color.getBlueByte();
	}
	
	public void init(GameContainer gc, Game game)
			throws SlickException {
		
		
		testmap = new Image("res/TestMap.png");
		bricks = new SpriteSheet("res/Bricks.png", 16, 16);
		bg = new Image("res/Bg.png");
		bg.setFilter(Image.FILTER_NEAREST);
		Blue = new Image("res/Blue.png");
		Blue.setFilter(Image.FILTER_NEAREST);
		shadow = new Image("res/Shadow.png");
		shadow.setFilter(Image.FILTER_NEAREST);
		
		Ninja = new SpriteSheet("res/Ninja.png", 16, 16);
		
		Finn = new SpriteSheet("res/Finn.png", 16, 16);
		Jake = new Image("res/Jake.png");
		Jake.setFilter(Image.FILTER_NEAREST);
		Snail = new Image("res/Snail.png");
		Snail.setFilter(Image.FILTER_NEAREST);
		attack = new SpriteSheet("res/Attack.png", 20, 32);
		attackdown = 0;
		dir = 0;
		
		mapW = testmap.getWidth();
		mapH = testmap.getHeight();
		
		level = new byte[mapW][mapH];
		ninjalevel = new byte[mapW][mapH];
		tiles = new Image[mapW][mapH];

		for(int y=0;y<mapH;y++){
			for(int x=0;x<mapW;x++){
				if(testmap.getColor(x, y).getAlpha() == 255){
					if(getHex(testmap.getColor(x, y)) == Integer.parseInt("FF0000", 16)){
						level[x][y] = 1;
						ninjalevel[x][y] = 0;
						System.out.print("[]");
					}else if(getHex(testmap.getColor(x, y)) == Integer.parseInt("FFFFFF", 16)){
						level[x][y] = 2;
						ninjalevel[x][y] = 0;
						desX = x;
						desY = y;
						camX = desX*16*zoom;
						camY = desY*16*zoom;
						System.out.print("SP");
					}else if(getHex(testmap.getColor(x, y)) == Integer.parseInt("0000FF", 16)){
						level[x][y] = 0;
						ninjalevel[x][y] = 10;
						System.out.print("<>");
					}else if(getHex(testmap.getColor(x, y)) == Integer.parseInt("FFFF00", 16)){
						level[x][y] = -3;
						ninjalevel[x][y] = 0;
						System.out.print("JD");
					}else if(getHex(testmap.getColor(x, y)) == Integer.parseInt("00FF00", 16)){
						level[x][y] = -2;
						ninjalevel[x][y] = 0;
						System.out.print("SN");
					}else {
						level[x][y] = 0;
						ninjalevel[x][y] = 0;
						System.out.print("  ");
					}
				}else{
					level[x][y] = 0;
					ninjalevel[x][y] = 0;
					System.out.print("  ");
				}
			}
			System.out.println();
		}
		
		for(int y=0;y<mapH;y++){
			for(int x=0;x<mapW;x++){
				if(x > 0 && y > 0 && x < mapW-1 && y < mapH-1){
					int selection = 0;
					
					if(level[x][y] == 1){
						selection += 1;
					}
					if(level[x+1][y] == 1){
						selection += 2;
					}
					if(level[x][y+1] == 1){
						selection += 4;
					}
					if(level[x+1][y+1] == 1){
						selection += 8;
					}
					
					tiles[x][y] = bricks.getSubImage(selection%4, Math.round(Math.round(Math.floor(selection/4))));
					
				}
			}
		}
		
		
		moving = false;
		movedown = 0;
	}

	public void render(GameContainer gc, Game game, Graphics g)
			throws SlickException {
		bg.getScaledCopy(zoom).draw(-camX%800, -camY%600+8*zoom);
		bg.getScaledCopy(zoom).draw(-camX%800, -camY%600+600+8*zoom);
		bg.getScaledCopy(zoom).draw(-camX%800+800, -camY%600+8*zoom);
		bg.getScaledCopy(zoom).draw(-camX%800+800, -camY%600+600+8*zoom);
		

		for(int y=desY-6*4/zoom;y<desY+6*4/zoom;y++){
			for(int x=desX-8*4/zoom;x<desX+8*4/zoom;x++){
				if(x > 0 && y > 0 && x < mapW-1 && y < mapH-1){
					
					if(level[x][y] == 2){
						tiles[x][y].getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2, y*16*zoom - camY + gc.getHeight()/2);
						//Blue.getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2 - 8*zoom, y*16*zoom - camY + gc.getHeight()/2 - 8*zoom);
					}else if(level[x][y] == -3){
						Jake.getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2 - 9*zoom, y*16*zoom - camY + gc.getHeight()/2 - 8*zoom);
						//Blue.getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2 - 8*zoom, y*16*zoom - camY + gc.getHeight()/2 - 8*zoom);
					}else if(level[x][y] == -2){
						Snail.getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2 - 9*zoom, y*16*zoom - camY + gc.getHeight()/2 - 8*zoom);
						//Blue.getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2 - 8*zoom, y*16*zoom - camY + gc.getHeight()/2 - 8*zoom);
					}else if(level[x][y] == -1){
						tiles[x][y].getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2, y*16*zoom - camY + gc.getHeight()/2);
						//tiles[x][y].draw(x*16*zoom - camX + gc.getWidth()/2 - 4*zoom, y*16*zoom - camY + gc.getHeight()/2 - 4*zoom);
					}else{
						tiles[x][y].getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2, y*16*zoom - camY + gc.getHeight()/2);
					}
					
					if(ninjalevel[x][y] >= 10){
						Ninja.getSubImage(ninjalevel[x][y]-10, 0).getScaledCopy(zoom).draw(x*16*zoom - camX + gc.getWidth()/2 - 8*zoom, y*16*zoom - camY + gc.getHeight()/2 - 8*zoom);
						//tiles[x][y].draw(x*16*zoom - camX + gc.getWidth()/2 - 4*zoom, y*16*zoom - camY + gc.getHeight()/2 - 4*zoom);
					}
					
				}
			}
		}
		
		if(moving == true){
			Finn.getSubImage(dir, Math.round( Math.round( Math.floor( anim/128 + 1) ) ) ).getScaledCopy(zoom).draw(gc.getWidth()/2-8*zoom, gc.getHeight()/2-8*zoom);
		}else{
			if(attackdown > 0){
				attack.getSubImage(dir, 0).getScaledCopy(zoom).draw(gc.getWidth()/2-10*zoom, gc.getHeight()/2-16*zoom);
			}else{
				Finn.getSubImage(dir, 0).getScaledCopy(zoom).draw(gc.getWidth()/2-8*zoom, gc.getHeight()/2-8*zoom);
			}
		}
		
	}

	public void update(GameContainer gc, Game game, int delta)
			throws SlickException {
		
		Input input = gc.getInput();
		/*for(int y=0;y<mapH;y++){
			for(int x=0;x<mapW;x++){
					
				if(level[x][y] == 1){
					System.out.print("[]");
				}else if(level[x][y] == 2){
					System.out.print(":D");
				}else{
					System.out.print("  ");
				}

			}
			System.out.println();
		}*/

		for(int d=0;d<delta;d++){

			if(attackdown == 100){
				
			}
			
			if(attackdown > 0){
				attackdown -= 1;
			}
			

			if(camX < desX*16*zoom){
				camX += 1/16F*zoom;
			}
			if(camX > desX*16*zoom){
				camX -= 1/16F*zoom;
			}
			if(camY < desY*16*zoom){
				camY += 1/16F*zoom;
			}
			if(camY > desY*16*zoom){
				camY -= 1/16F*zoom;
			}
			
			
			if(Math.round(camX) == desX*16*zoom && Math.round(camY) == desY*16*zoom){
				if(movedown > 0){
					movedown -= 1;
				}
				if(movedown <= 0){
					moving = false;
					movedown = 0;
				}
			}else{
				if(moving == false){
					anim = 256;
				}
				if(anim > 0){
					anim -= 1;
					//System.out.println(anim);
				}
				moving = true;
				movedown = 50;
			}
			
			if(moving == false){
				if(Math.round(camX) == desX*16*zoom){
					if(input.isKeyDown(Input.KEY_A) && !input.isKeyDown(Input.KEY_D) && !input.isKeyDown(Input.KEY_W) && !input.isKeyDown(Input.KEY_S)){
						dir = 1;
						if(level[desX-1][desY] <= 0){
							if(level[desX-1][desY] == -3){
								System.out.println("WIN");
								game.enterState(2);
							}
							level[desX][desY] = 0;
							level[desX-1][desY] = 2;
							desX -= 1;
							moveEnemies();
						}
					}
				}
		
				if(Math.round(camX) == desX*16*zoom){
					if(input.isKeyDown(Input.KEY_D) && !input.isKeyDown(Input.KEY_A) && !input.isKeyDown(Input.KEY_W) && !input.isKeyDown(Input.KEY_S)){
						dir = 3;
						if(level[desX+1][desY] <= 0){
							if(level[desX+1][desY] == -3){
								System.out.println("WIN");
								game.enterState(2);
							}
							level[desX][desY] = 0;
							level[desX+1][desY] = 2;
							desX += 1;
							moveEnemies();
						}
					}
				}
		
				if(Math.round(camY) == desY*16*zoom){
					if(input.isKeyDown(Input.KEY_W) && !input.isKeyDown(Input.KEY_A) && !input.isKeyDown(Input.KEY_D) && !input.isKeyDown(Input.KEY_S)){
						dir = 2;
						if(level[desX][desY-1] <= 0){
							if(level[desX][desY-1] == -3){
								System.out.println("WIN");
								game.enterState(2);
							}
							level[desX][desY] = 0;
							level[desX][desY-1] = 2;
							desY -= 1;
							moveEnemies();
						}
					}
				}
		
				if(Math.round(camY) == desY*16*zoom){
					if(input.isKeyDown(Input.KEY_S) && !input.isKeyDown(Input.KEY_A) && !input.isKeyDown(Input.KEY_D) && !input.isKeyDown(Input.KEY_W)){
						dir = 0;
						if(level[desX][desY+1] <= 0){
							if(level[desX][desY+1] == -3){
								System.out.println("WIN");
								game.enterState(2);
							}
							level[desX][desY] = 0;
							level[desX][desY+1] = 2;
							desY += 1;
							moveEnemies();
						}
					}
				}
			}
			
			
		}
		
		if(moving == false){
			if(input.isKeyPressed(Input.KEY_UP)){
				dir = 2;
				attackdown = 100;
				if(ninjalevel[desX][desY-1] >= 10){
					ninjalevel[desX][desY-1] = 0;
				}
			}
			
			if(input.isKeyPressed(Input.KEY_DOWN)){
				dir = 0;
				attackdown = 100;
				if(ninjalevel[desX][desY+1] >= 10){
					ninjalevel[desX][desY+1] = 0;
				}
			}
			
			if(input.isKeyPressed(Input.KEY_LEFT)){
				dir = 1;
				attackdown = 100;
				if(ninjalevel[desX-1][desY] >= 10){
					ninjalevel[desX-1][desY] = 0;
				}
			}
			
			if(input.isKeyPressed(Input.KEY_RIGHT)){
				dir = 3;
				attackdown = 100;
				if(ninjalevel[desX+1][desY] >= 10){
					ninjalevel[desX+1][desY] = 0;
				}
			}
		}
		
	}

	private void moveEnemies() {
		byte[][] deslevel = new byte[mapW][mapH];
		for(int y=0;y<mapH;y++){
			for(int x=0;x<mapW;x++){
				deslevel[x][y] = ninjalevel[x][y];
			}
		}
		for(int y=desY-6*4/zoom;y<desY+6*4/zoom;y++){
			for(int x=desX-8*4/zoom;x<desX+8*4/zoom;x++){
				boolean moved = false;
				//deslevel[x][y] = ninjalevel[x][y];
				if(x > 0 && y > 0 && x < mapW-1 && y < mapH-1){
					if(ninjalevel[x][y] >= 10){
						for(int i=-5;i<5;i++){
							for(int j=-5;j<5;j++){
								if(moved == false){
									if(level[x+i][y+j] == 2){
										System.out.println("DETECTED" + i + " , " + j);
										moved = true;
										if(Math.abs(i) == 1 && Math.abs(j) == 1 ){
											if(level[x+i][y] <= 0){
												deslevel[x+i][y] = 13;
												deslevel[x][y] = 0;
											}else if(level[x][y+j] <= 0){
													deslevel[x][y+j] = 12;
													deslevel[x][y] = 0;
											}
										}else if(Math.abs(i - j) <= 1 && (Math.abs(i) <= 1 || Math.abs(j) <= 1)){
											
										}else if(Math.abs(i) >= Math.abs(j)){
											if(i > 0){
												if(level[x+1][y] <= 0){
													deslevel[x+1][y] = 13;
													deslevel[x][y] = 0;
												}else if(j > 0){
													if(level[x][y+1] <= 0){
														deslevel[x][y+1] = 12;
														deslevel[x][y] = 0;
													}
												}else{
													if(level[x][y-1] <= 0){
														deslevel[x][y-1] = 10;
														deslevel[x][y] = 0;
													}
												}
											}else if(i < 0){
												if(level[x-1][y] <= 0){
													deslevel[x-1][y] = 13;
													deslevel[x][y] = 0;
												}else if(j > 0){
													if(level[x][y+1] <= 0){
														deslevel[x][y+1] = 12;
														deslevel[x][y] = 0;
													}
												}else{
													if(level[x][y-1] <= 0){
														deslevel[x][y-1] = 10;
														deslevel[x][y] = 0;
													}
												}
											}
										}else{
											if(j > 0){
												if(level[x][y+1] <= 0){
													deslevel[x][y+1] = 13;
													deslevel[x][y] = 0;
												}else if(i > 0){
													if(level[x+1][y] <= 0){
														deslevel[x+1][y] = 12;
														deslevel[x][y] = 0;
													}
												}else{
													if(level[x-1][y] <= 0){
														deslevel[x-1][y] = 10;
														deslevel[x][y] = 0;
													}
												}
											}else if(j < 0){
												if(level[x][y-1] <= 0){
													deslevel[x][y-1] = 13;
													deslevel[x][y] = 0;
												}else if(i > 0){
													if(level[x+1][y] <= 0){
														deslevel[x+1][y] = 12;
														deslevel[x][y] = 0;
													}
												}else{
													if(level[x-1][y] <= 0){
														deslevel[x-1][y] = 10;
														deslevel[x][y] = 0;
													}
												}
											}
										}
									}
								}
							}
						}

					}
					//System.out.println(ninjalevel[x][y]);
				}
			}
		}
		for(int y=desY-6*4/zoom;y<desY+6*4/zoom;y++){
			for(int x=desX-8*4/zoom;x<desX+8*4/zoom;x++){
				ninjalevel[x][y] = deslevel[x][y];
			}
		}
	}

	public int getID() {
		return 0;
	}

}

